      program driver1
c     Xu interpolation on the square [-1,1]^2
      implicit none
      integer degmax,nxuptm,ntgptm,nx,type,dim
      parameter (degmax=1000,nxuptm=degmax*(degmax+2)/2,ntgptm=50000,
     1     dim=2)
      integer nxupt,ntgpt,deg,i
      double precision scale1,shift1,scale2,shift2,funct,passo,err,
     1     x1,x2,pi
      external funct,idem
      double precision vertex(4),xupt(nxuptm),yupt(nxuptm),
     1     fxupt(nxuptm),xtgpt(ntgptm),ytgpt(ntgptm),ftgpt(ntgptm),
     2     poltgt(ntgptm)
      real time
      pi=acos(-1.0d0)
      open(5,file='input1',status='old')
      read(5,*) (vertex(i),i=1,4)
      scale1=(vertex(2)-vertex(1))/2
      shift1=vertex(1)+scale1
      scale2=(vertex(4)-vertex(3))/2
      shift2=vertex(3)+scale2
      read(5,*) type
      read(5,*) nx
      if (type.gt.1) then
         ntgpt=nx**2
         passo=2.d0/(nx-1)
      else
         ntgpt=nx
      end if   
      read(5,*) deg
      if (mod(deg,2).eq.0) then
         write(6,*) 'Deg must be odd'
         stop
      end if

      close(5)
c     
c     Target points on square
c
      write(20,*) '# Function at ',ntgpt,' target points'
      do i=1,ntgpt
         call getnode(i,nx,passo,x1,x2,type)
         xtgpt(i)=scale1*x1+shift1
         ytgpt(i)=scale2*x2+shift2
         ftgpt(i)=funct(xtgpt(i),ytgpt(i),idem)
         write(20,1) xtgpt(i),ytgpt(i),ftgpt(i)
      end do   
c
c     Xu points on square
c
      deg=deg+1
      call bldxu(deg,xupt,yupt,nxupt)
      deg=deg-1
      write(21,*) '# Function at ',nxupt,' Xu points'
      do i=1,nxupt
         x1=scale1*cos(xupt(i))+shift1
         x2=scale2*cos(yupt(i))+shift2
         fxupt(i)=funct(x1,x2,idem)
         write(21,1) x1,x2,fxupt(i)
      end do   
      write(6,*) 'Computing the interpolant...'
c      call tim(time,1)
      call interp(deg+1,xupt,yupt,fxupt,nxupt,xtgpt,ytgpt,
     1     poltgt,ntgpt,scale1,shift1,scale2,shift2)
c      call tim(time,2)
c      write(6,*) 'Elapsed time: ',time
      write(6,*) 'Writing interpolant...'
      write(22,*) '# Interpolant at ',ntgpt,' target points'
      do i=1,ntgpt
         write(22,1) xtgpt(i),ytgpt(i),poltgt(i)
      end do   
      write(6,*) 'Computing errors...'
      err=0.0d0
      do i=1,ntgpt
         err=max(err,abs(poltgt(i)-ftgpt(i)))
c         err=max(err,abs(poltgt(i)))
      end do   
      write(6,2) 'Xu error on target points ',err
      write(6,*)
      write(6,*) 'Function on target points on fort.20'
      write(6,*) 'Function on Xu points on     fort.21'
      write(6,*) 'Xu on target points on       fort.22'
 1    format(3(1x,e23.16))
 2    format(1x,a26,1x,e9.3)
      stop
      end
